//============================================================================
//  aPCI-8806 for PCI Linux Device Driver
//  apci8806.h
//  Author  Shoichiro Ito(ADTEK SYSTEM SCIENCE Co.,Ltd.)
//  Date    2001/03/29
//  Rev.    1.0.0
//============================================================================


#ifndef __INC_APCI8806_H__
#define __INC_APCI8806_H__


//-----------------------------------------------------------
//  Macros to help debugging
//-----------------------------------------------------------

#undef PDEBUG		  /* undef it, just in case */
#ifdef APCI8806_DEBUG
#	ifdef __KERNEL__
		/* This one if debugging is on, and kernel space */
#		define PDEBUG(fmt, args...) printk(KERN_DEBUG "[APCI8806]: " fmt, ## args)
#	else
		/* This one for user space */
#		define PDEBUG(fmt, args...) fprintf(stderr, fmt, ## args)
#	endif
#else
#	define PDEBUG(fmt, args...) /* not debugging: nothing */
#endif

#undef PDEBUGG
#define PDEBUGG(fmt, args...) /* nothing: it's a placeholder */


//-----------------------------------------------------------
//  Miscellaneous
//-----------------------------------------------------------

#define APCI8806_MAX_DEVICES	16		// ǥХ

#define APCI8803_DA_TIMEOUT	100		// D/A Ԥ(us)


//-----------------------------------------------------------
//  Channel range
//-----------------------------------------------------------

#define APCI8806_CH_FIRST	0
#define APCI8806_CH_LAST	3


//-----------------------------------------------------------
//  Channel
//-----------------------------------------------------------

#define APCI8806_CH_01		0
#define APCI8806_CH_02		1
#define APCI8806_CH_03		2
#define APCI8806_CH_04		3


//-----------------------------------------------------------
//  Device I/O Defined
//-----------------------------------------------------------

// Input Ports

#define APCI8806_IN_PORT	0x00	// ƥơϥǡݡ

// Output ports

#define APCI8806_OUT_PORT	0x00	// D/A ǡݡ

// Offset 0x00	    APCI8806_IN_PORT(I)

#define APCI8806_DA_BUSY	0x01	// D/A ǡž
#define APCI8806_EXIN1		0x04	// ϥݡ CH1
#define APCI8806_EXIN2		0x08	// ϥݡ CH2


//-----------------------------------------------------------
//  Device I/O Control Codes
//-----------------------------------------------------------

#define APCI8806_IOC_MAGIC	'Z'

#define APCI8806_SET_DA_DATA	_IOW (APCI8806_IOC_MAGIC, 0, apci8806_da)
#define APCI8806_GET_EXIN	_IOR (APCI8806_IOC_MAGIC, 1, unsigned char)

#define APCI8806_IOC_MAXNR	1


// TODO:  桼ץꥱȤ̿Ѥǡ¤򤳤˵Ҥޤ

typedef struct _apci8806_da
{
	unsigned short value;
	unsigned short ch;
} apci8806_da, *papci8806_da;


#endif // __INC_APCI8806_H__
